#!/bin/sh
# This writes the S-record-style header for flashing with GERMS monitor.

# read the # of to be copied bytes from stdin, passed from makefile
read len

# input is the size, can be hex, convert it to decimal
len=$(printf "%d" $len)

# flash sector start address
addr=$(printf "%d" 0x40000)


printf "# file: tomcat.flash\n"
printf "#\n"
printf "# This file generated by %s,\n" $0
printf "# a script to prepend the bootloader with flash erase commands.\n"
printf "# This file contains a short program to run out of flash memory\n"
printf "# which copies the main program down to RAM, and executes it there.\n"
printf "#\n"
printf "# Original file: tomcat.srec\n"
printf "#   System name: TCCPU\n"
printf "#     Generated: "
date
printf "#\n"
printf "# flash address: 0x%08x\n" $addr
printf "#   ram address: 0x00800000\n"
printf "#     copy size: 0x%08x\n" $len
printf "#\n"
printf "r0\n"
printf "#\n"
printf "# Erase enough flash sectors\n"
printf "#\n"

# write the required erase commands, rounded up to 64K
while [ $len -gt 0 ]
do
	printf "e%08x\n" $addr
	addr=$(expr $addr + 65536)
	len=$(expr $len - 65536)
done

printf "#\n"
printf "# Bootloader\n"
printf "#\n"

# the bootloader itself and the main program is appended by the makefile
